AchievementFireLightFrost = class(Turbine.UI.Control)
function AchievementFireLightFrost:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.skillList = {
        -- frost
        ["Chilling Rhetoric"] = 1,
        ["Essence of Winter"] = 1,
        ["Flurry of Words"] = 1,

        -- lightning
        ["Scribe's Spark"] = 2,
        ["Shocking Words"] = 2,
        ["Essence of Storm"] = 2,
        ["Shocking Touch"] = 2,
        ["Writ of Lightning"] = 2,
        ["Sustaining Bolt"] = 2,
        ["Ceasless Argument"] = 2,
        ["Epic Conclusion"] = 2,
        ["Concession and Rebuttal"] = 2,
        ["Fulgurite Rune-stone"] = 2,
        ["Static Surge"] = 2,

        -- fire        
        ["Fiery Ridicule"] = 3,
        ["Distracting Flame"] = 3,
        ["Writ of Fire"] = 3,
        ["Smouldering Wrath"] = 3,
        ["Scathing Mockery"] = 3,
        ["Essence of Flame"] = 3,
        ["Combustion"] = 3,
        ["Volcanic Rune-stone"] = 3,
        ["Essay of Fire"] = 3,
    }

    self.playerName = Turbine.Gameplay.LocalPlayer.GetInstance():GetName()

    self.command = Turbine.ShellCommand()
    function self.command:Execute()
        HardcoreHandler:GetAchievementHint("Fire, Light & Frost")
    end

    Turbine.Shell.AddCommand("hardcorefirelightandfrost", self.command)
    ChatOutput("Use the command /hardcorefirelightandfrost to see a list of affected skills")


    self.handler = handler

    self.skillToken = 0

    self:SetCallbacks()
end

function AchievementFireLightFrost:SetCallbacks()
    self.skillCallbacks = {}
    for key, value in pairs(SkillEventHandler:GetSkills()) do
        if self.skillList[key] then

            table.insert(self.skillCallbacks, AddCallback(SkillEventHandler, key, function(skill) 
                if self.skillList[key] == self.skillToken then
                    self.handler:Fail("Fire, Light & Frost", "Illegal skill use", 0x410E81CB)
                end
                self.skillToken = self.skillList[key]
            end))
        end
    end
end

function AchievementFireLightFrost:Unload()
    for key, value in pairs(self.skillCallbacks) do
        RemoveCallback(SkillEventHandler, key, value) 
    end
end

function AchievementFireLightFrost:Refresh()
    self:Unload()
    self:SetCallbacks()
end

function AchievementFireLightFrost:GetHint()
    for key, value in PrimeUtils.Utils.spairs(self.skillList, function(t, a, b) return a < b end) do
       ChatOutput(key)
    end
end